=== debian/changelog ===
getdp (3.5.0+dfsg1-5) unstable; urgency=medium

  * Team upload.

  [ Alexandre Detiste ]
  * [e7e7bbb] remove ancient SVN script

  [ Francesco Ballarin ]
  * [d8fca99] Update Francesco Ballarin's email address
  * [8397653] Trim trailing whitespace in changelog.
  * [8802775] Remove trailing whitespace in debian/copyright (routine-update)
  * [9e89be1] Use secure URI in Homepage field.
  * [7067a72] Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Adrian Bunk ]
  * Backport upstream fix for FTBFS with CMake 4. Closes: #1112948.

 -- Santiago Vila <sanvila@debian.org>  Mon, 13 Oct 2025 19:50:00 +0200

getdp (3.5.0+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * Fix Team name
  * Standards-Version: 4.7.2

 -- Alexandre Detiste <tchet@debian.org>  Wed, 23 Apr 2025 13:47:39 +0200

getdp (3.5.0+dfsg1-3) unstable; urgency=medium

  * [f59522d] OpenMPI 5.0 changed the name of the environment variable to set the SSH
    agent from
       export OMPI_MCA_plm_rsh_agent=/bin/false
    to
       export PRTE_MCA_plm_ssh_agent=/bin/false
    Use the new variable name in debian/rules.
  * [4b0bf11] Set lower bound >= 1.17 to Build-Depends: mpi-default-dev because the environment
    variable PRTE_MCA_plm_ssh_agent is set at build time in debian/rules

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 20 Nov 2024 07:23:16 +0000

getdp (3.5.0+dfsg1-2) unstable; urgency=medium

  * [c9f0c0f] Add Francesco Ballarin to uploaders
  * [73104c0] Fix lintian error E: getdp source: duplicate-globbing-patterns Interface/ProParser.tab.hpp (lines 54 59) [debian/copyright]

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 14 Apr 2024 16:58:51 +0000

getdp (3.5.0+dfsg1-1) experimental; urgency=medium

  [ Christophe Trophime ]
  * [9cd3415] fix #927140

  [ Francesco Ballarin ]
  * [791deb1] New upstream version 3.5.0+dfsg1
  * [8251bbf] Drop debian/patches/petsc-dev-5f171b22.patch: upstream now handles switching between PCFactorSetMatSolverPackage and PCFactorSetMatSolverType with a #define
  * [a9f0161] Refresh localise_toplevel_htmldoc.patch
  * [51d021b] Refresh petsc.patch
  * [eef3901] Refresh link_fortran.patch
  * [3c66539] Add libeigen3-dev to build dependencies, because getdp/src/functions/BF_Node.cpp includes gmsh/fullMatrix.h, which in turn includes Eigen/Dense
  * [17a1f7b] New patch add_eigen_include_directories.patch to ensure that system-wide installation of eigen is picked up by cmake
  * [5962679] demos were renamed to examples in upstream commit f448f64013ae928419262f27dd2cd81fee35c631
  * [d3012f4] Bump debhelper-compat to 13
  * [6894390] Enable salsa CI

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 14 Apr 2024 08:24:01 +0000
