=== debian/control ===
Source: getdp
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
           Francesco Ballarin <ballarin@debian.org>
Section: math
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               gfortran,
               libarpack2-dev,
               libgsl-dev,
               libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
               liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
               libeigen3-dev,
               libgmsh-private-headers-dev,
               mpi-default-dev (>= 1.17),
               petsc-dev,
               python3-dev,
               slepc-dev,
               swig,
               texlive,
               texlive-plain-generic,
               texinfo
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/getdp
Vcs-Git: https://salsa.debian.org/science-team/getdp.git
Homepage: https://www.geuz.org/getdp

Package: getdp
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp

Package: getdp-sparskit
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp
 .
 Getdp is compiled with SPARSKIT support
